Rem
bbdoc: MaxGUI Drivers/FLTKMaxGUI
End Rem
Module MaxGUI.FLTKMaxGUI

Strict

Import pub.zlib
Import pub.libpng
'Import pub.libjpeg

ModuleInfo "Version: 1.56"
ModuleInfo "Author: Simon Armstrong, Seb Hollington"
ModuleInfo "License: zlib/libpng"
ModuleInfo "Copyright: Blitz Research Ltd."

ModuleInfo "Credit: FLTKMaxGUI is based in part on the work of the FLTK project (http://www.fltk.org)."
ModuleInfo "Credit: FLTKMaxGUI also uses the fantastic FLTK Utility Widgets from http://www.osc.edu/archive/FLU/ ."

ModuleInfo "History: 1.56 Release"
ModuleInfo "History: Added GetStatusText() implementation."
ModuleInfo "History: Added missing Class() methods to TFLTextField and TFLLabel."
ModuleInfo "History: Fixed RequestColor() parameter passing."
ModuleInfo "History: Fixed pasting into text areas to work with WINDOW_ACCEPTFILES flag."
ModuleInfo "History: 1.55 Release"
ModuleInfo "History: Added hack to fix X crash that appeared when Ubuntu's Maximus is running."
ModuleInfo "History: Bumped FLTK 1.3 version to rev. 7652."
ModuleInfo "History: Added support for new PANEL_RAISED style flag."
ModuleInfo "History: 1.54 Release"
ModuleInfo "History: Fixed label background colors not showing."
ModuleInfo "History: 1.53 Release"
ModuleInfo "History: Added LookupColor() method to TFLTKGUIDriver."
ModuleInfo "History: 1.52b Release"
ModuleInfo "History: Disabled FLTK text widgets pasting file-names when files are dropped onto a window."
ModuleInfo "History: 1.52 Release"
ModuleInfo "History: Bumped FLTK 1.3 version to rev. 7062 to fix OS X compilation issues with GCC 3."
ModuleInfo "History: 1.51b Release"
ModuleInfo "History: Fixed button image offset when no text is displayed."
ModuleInfo "History: 1.50 Release"
ModuleInfo "History: Merged in markcw's latest Fl_Help_View changes which include basic CSS support! :-)"
ModuleInfo "History: Updated FLTK 1.3.x library to revision 6980 (fixes a few Cocoa bugs)."
ModuleInfo "History: Added MacOS compilation support."
ModuleInfo "History: 1.49 Release"
ModuleInfo "History: Fixed filename_list.cxx compile error on Ubuntu 9.10."
ModuleInfo "History: Bumped FLTK 1.3.x version to rev. 6948."
ModuleInfo "History: 1.48b Release"
ModuleInfo "History: Fixed GCC 4.4.1 compiler errors - thanks Otus (/Community/posts.php?topic=87472)."
ModuleInfo "History: 1.48 Release"
ModuleInfo "History: Added icon support to list boxes (http://www.fltk.org/str.php?L1739)."
ModuleInfo "History: Fixed another memory corruption bug concerning incorrectly casting toolbar Fl_Group to Fl_Panel."
ModuleInfo "History: Fixed group panel label background so that it is 'transparent'."
ModuleInfo "History: Implemented primitive software-based pixmap scaling for panels."
ModuleInfo "History: Updated FLTK library to FLTK 1.3 rev. 6873."
ModuleInfo "History: Disabled XDBE for Linux as it was sometimes causing black flickering on window resize."
ModuleInfo "History: (Finally) found and fixed the memory corruption bug in Fl_Menu and plugged up a memory leak."
ModuleInfo "History: Fixed textarea paste crash."
ModuleInfo "History: Fixed UpdateWindowMenu() crash."
ModuleInfo "History: Toolbars now push down the client area of the parent window."
ModuleInfo "History: More work to improve handling of WINDOW_CLIENTCOORDS style."
ModuleInfo "History: Hacked in 'xdg-get-user-path' for Flu_File_Chooser using Brucey's kindly donated BaH.Volumes code."
ModuleInfo "History: Added user_data() node information to speed up treeviews and event generation."
ModuleInfo "History: Added maximize() and restore() methods for Fl_AWindow."
ModuleInfo "History: Fixed textfields with TEXTFIELD_PASSWORD style."
ModuleInfo "History: Added hover effect for non-standard push-buttons and non-editable comboboxes."
ModuleInfo "History: Reworked event handling to use extremely nice and tidy C++ template system - improves mouse/keyboard event generation."
ModuleInfo "History: Fixed SelectedTreeViewNode() and EVENT_GADGETMENU on treeviews."
ModuleInfo "History: 1.47 Release"
ModuleInfo "History: Fixed textfield crash upon typing."
ModuleInfo "History: Fixed stray EVENT_GADGETACTION event when enter was pressed in a textfield."
ModuleInfo "History: Fixed push buttons losing background colors on mouse hover."
ModuleInfo "History: Implemented new trial OnMouse() and OnKey() system for generating mouse and key events, that facilitates SetSensitivity()."
ModuleInfo "History: Added Flmm_Tabs so that, when too many tabs are added to a tabber, a drop-down menu is shown instead of squashing them up."
ModuleInfo "History: Added degac's label text fix."
ModuleInfo "History: LABEL_FRAME border fix."
ModuleInfo "History: 1.46 Release"
ModuleInfo "History: Added toolbar separators."
ModuleInfo "History: Fixed comboboxes losing selection after ModifyGadgetItem."
ModuleInfo "History: Fixed RemoveGadgetItem on toolbars."
ModuleInfo "History: 1.45 Release"
ModuleInfo "History: Added XPMFromPixmap() function to TFLWidget to enable support for window icons."
ModuleInfo "History: Other clearing up."
ModuleInfo "History: 1.44 Release"
ModuleInfo "History: Fixed window SetGadgetText() memory leak and stray WidgetHandle() as a parameter."
ModuleInfo "History: Uncommented XCloseIM() from Fl_x.cxx - cause of memory leak."
ModuleInfo "History: Latest set of markcw's Fl_Help_View fixes - see http://www.blitzbasic.com/Community/posts.php?topic=79280#947564."
ModuleInfo "History: 1.43 Release"
ModuleInfo "History: FLTK's event system will now completely override over BRL.System's default."
ModuleInfo "History: All function externs and constants have been moved to a separate, privately included fltkdecls.bmx."
ModuleInfo "History: 1.42 Release"
ModuleInfo "History: Fixed double event for EVENT_MOUSEDOWN and hacked in workaround for missing XEvents."
ModuleInfo "History: 1.41 Release"
ModuleInfo "History: Modified TFLPanel's event handling code so that it makes use of SetSensitivity()/GetSensitivity()."
ModuleInfo "History: SelectTreeViewNode(TreeViewRoot(treeView)) now deselects the currently selected node."
ModuleInfo "History: Fixed missing EVENT_WINDOWACCEPT events."
ModuleInfo "History: Updated FLTK 1.3 library to revision 6719."
ModuleInfo "History: 1.40 Release"
ModuleInfo "History: Updated FLTK 1.3 library to revision 6663."
ModuleInfo "History: 1.39 Release"
ModuleInfo "History: Added hack to scale up font sizes on Windows."
ModuleInfo "History: Committed version with FreeType support enabled by default."
ModuleInfo "History: 1.38 Release"
ModuleInfo "History: Fixed window disabling."
ModuleInfo "History: Added markcw's HTMLView forward/back code - thanks Mark."
ModuleInfo "History: Fixed event.data on button EVENT_GADGETACTION."
ModuleInfo "History: Tweaked to allow module to compile and run on Windows."
ModuleInfo "History: Fixed missing mouse wheel events on canvas."
ModuleInfo "History: Improved font handling and FontRequest() window."
ModuleInfo "History: Updated to FLTK 1.3, rev 6649."
ModuleInfo "History: 1.37 Release"
ModuleInfo "History: Skid's GCC 4.X fixes."
ModuleInfo "History: Fixed crash when freeing Fl_Text_Display."
ModuleInfo "History: Radio buttons and check boxes should now be left-aligned."
ModuleInfo "History: 1.36 Release"
ModuleInfo "History: Loads more Fl_Help_View fixes courtesy of markcw."
ModuleInfo "History: 1.35 Release"
ModuleInfo "History: Added prelimary pixmap support for push-buttons."
ModuleInfo "History: Added text support for group-panels."
ModuleInfo "History: 1.34 Release"
ModuleInfo "History: Tweaked Fl_Color to accept a wider range of formatting color contrasts before resorting to black or white defaults."
ModuleInfo "History: 1.33 Release"
ModuleInfo "History: Added SetTextColor() method to allow for multi-colored widgets."
ModuleInfo "History: Added a MaxGUI style stepper, complete with repeat buttons."
ModuleInfo "History: 1.32 Release"
ModuleInfo "History: Completely restructured fltkgui.bmx into OO code."
ModuleInfo "History: Fixed a small memory leak in text area and treeview."
ModuleInfo "History: Fixed OK button text getting corrupted by the new Flu_Button."
ModuleInfo "History: RequestFont() dialog should now be modal."
ModuleInfo "History: Another set of markcw's Fl_Help_View fixes."
ModuleInfo "History: 1.30 Release"
ModuleInfo "History: Implemented the FLU Tree Browser to replace the old list-box based treeview."
ModuleInfo "History: Increased clipping stack length in Fl_Rect.cxx to suppress warnings when running MaxIDE."
ModuleInfo "History: Replaced Fl_Button and Fl_Return_Button with Flu_Button and Flu_Return_Button."
ModuleInfo "History: Some more Fl_Help_View fixes from markcw."
ModuleInfo "History: 1.29 Release"
ModuleInfo "History: Fixed an undo bug in IDE by getting FLTK to mimic Win32/Cocoa textarea event behaviour more closely."
ModuleInfo "History: Dropped in the FLU file requester to replace the default FLTK one."
ModuleInfo "History: Some more of markcw's Fl_Help_View.cxx fixes."
ModuleInfo "History: Copied FLU source into FLTKMaxGUI folder."
ModuleInfo "History: 1.28 Release"
ModuleInfo "History: Added Fl_Multi_List handling code."
ModuleInfo "History: Corrected logic error that was allowing only left-mouse clicks to pass through to widgets."
ModuleInfo "History: Added error handler to fl_read_image.cxx to catch XGetImage exceptions and handle them safely."
ModuleInfo "History: 1.27 Release"
ModuleInfo "History: Added EVENT_GADGETMENU for tabbers."
ModuleInfo "History: Improved layout of PANEL_GROUP."
ModuleInfo "History: Added the latest set of markcw's Fl_Help_View.cxx fixes."
ModuleInfo "History: 1.26 Release"
ModuleInfo "History: Changed the status-bar border so that it looks more like one."
ModuleInfo "History: BUTTON_DEFAULT now uses Fl_Return_Button instead."
ModuleInfo "History: Fixed strange EventX/EventY coords in EVENT_WINDOWMOVE and EVENT_WINDOWSIZE."
ModuleInfo "History: Done some work cleaning up EVENT_GADGETSELECT generation by textareas."
ModuleInfo "History: Added CharX() and CharY() methods."
ModuleInfo "History: 1.25 Release"
ModuleInfo "History: Windows are now extending Fl_Double_Buffer to reduce random drawing artifacts."
ModuleInfo "History: Child windows should now stay on top, but behaviour still isn't exactly the same as Win32 or Cocoa."
ModuleInfo "History: Default message box font is now set to match other fonts."
ModuleInfo "History: Added clip_children() calls to Fl_Group based widgets."
ModuleInfo "History: Added some more of markcw's Fl_Help_View.cxx fixes."
ModuleInfo "History: Changed menu appearance and fixed label SetGadgetFont() redraw problems."
ModuleInfo "History: Changed default font size for FLTK to size 12 (in Fl_Widget.cxx)."
ModuleInfo "History: Tidied up RequestFont() dialog layout and positioning."
ModuleInfo "History: Added standardized FLTK LookupGuiFont() handling."
ModuleInfo "History: Added support for TEXTAREA_WORDWRAP flag."
ModuleInfo "History: Added Fl::get_system_colors() to flReset() so that FLTK looks a bit more like the other apps."
ModuleInfo "History: Hacked in an editable combobox, but no EVENT_GADGETSELECT yet."
ModuleInfo "History: Added markcw's Fl_Help_View.cxx tweaks - thanks Mark!"
ModuleInfo "History: 1.24 Release"
ModuleInfo "History: Fixed FL timers and therefore tooltips."
ModuleInfo "History: EventExtra() now contains the selected item's extra object for tabbers."
ModuleInfo "History: All right-clicks are ignored internally in FL_TEXTEDITORs."
ModuleInfo "History: Added SetMaxWindowSize() support."
ModuleInfo "History: Found and fixed glibc error originating from flRedirectView() in fltkglue.cpp."
ModuleInfo "History: Swapped Fl_Select_Browser with Fl_Hold_Browser so that highlight remains after mouse button is released."
ModuleInfo "History: Added EVENT_GADGETMENU for treeviews."
ModuleInfo "History: Hacked Fl_X.cxx to fix file drag n' drop support."
ModuleInfo "History: Added alpha-support for pixmaps on panels."
ModuleInfo "History: Added tab text alignment in the status bar similar to Win32, GTK and Cocoa."
ModuleInfo "History: Added support for windows without the WINDOW_TITLEBAR flag."
ModuleInfo "History: Added support for the TEXTFORMAT_BOLD and TEXTFORMAT_ITALIC flags in Text Areas."
ModuleInfo "History: Fixed EVENT_GADGETACTION on text-areas/text-fields."
ModuleInfo "History: Fixed gadget filter key codes, so that the tab key sends the correct data."
ModuleInfo "History: Fixed (somewhat) active panel events and attempted to eliminate double firing."
ModuleInfo "History: Imporoved toolbars."
ModuleInfo "History: Switched to GTK+ FLTK theme, and removed black tabs and yellow highlighting."
ModuleInfo "History: Fixed a glibc error in Fl_Text_Display.cxx."
ModuleInfo "History: Fixed Fl_HelpView image freeing crash with broken_image substitute."
ModuleInfo "History: Changed Fl_Panel so that it uses FL_NO_BOX, and fixed XGetImage crash in Fl_x.cxx"
ModuleInfo "History: Swapped out source code for FLTK 1.1.9."
ModuleInfo "History: 1.23 Release"
ModuleInfo "History: Removed Fl_Text_Editor.cxx right mouse-button handling that was clearing selection."
ModuleInfo "History: Added new BUTTON_PUSH support for radio/checkboxes."
ModuleInfo "History: 1.22 Release"
ModuleInfo "History: Added Class() method for new GadgetClass() function."
ModuleInfo "History: 1.21 Release"
ModuleInfo "History: Removed pixmap field from TFLIconStrip that was conflicting with field in inherited TIconStrip."
ModuleInfo "History: 1.20 Release"
ModuleInfo "History: Fixed SetPanelColor not redrawing"
ModuleInfo "History: 1.19 Release"
ModuleInfo "History: Fixed SetPanelPixmap panel,Null crash"
ModuleInfo "History: 1.18 Release"
ModuleInfo "History: Fixed panel not clipping children"
ModuleInfo "History: 1.17 Release"
ModuleInfo "History: Fixed crash removing last item of a Tabber"
ModuleInfo "History: 1.16 Release"
ModuleInfo "History: Added GetText and SetText methods to TFLNode class"
ModuleInfo "History: 1.15 Release"
ModuleInfo "History: Fixed broken shortcuts due to panel changes"
ModuleInfo "History: 1.14 Release"
ModuleInfo "History: Fixed TFLMenu.GetText"
ModuleInfo "History: Implemented KEY_REPEAT for canvas and active panels"
ModuleInfo "History: 1.13 Release"
ModuleInfo "History: FLTKSystem OpenURL now uses new system.linux implementation"
ModuleInfo "History: Added PopupMenu extra parameter support"
ModuleInfo "History: 1.12 Release"
ModuleInfo "History: Added Brucey's GADGETLOSTFOCUS tweak"
ModuleInfo "History: 1.11 Release"
ModuleInfo "History: ListBox now fires GADGETSELECT, GADGETACTION and GADGETMENU events"
ModuleInfo "History: Fixed SetGadgetText for checkboxes and radiobuttons courtesy Byteemoz"
ModuleInfo "History: 1.10 Release"
ModuleInfo "History: Initial OpenURL support for fltksystem using firefox - remote"
ModuleInfo "History: Initial MinimizeWindow support"
ModuleInfo "History: 1.09 Release"
ModuleInfo "History: Fixed radio buttons to exclude others in group"
ModuleInfo "History: Fixed TFLWidget.kids usage"
ModuleInfo "History: Fixed FreeGadget flwindow"
ModuleInfo "History: Fixed ClearGadgetItems combobox"
ModuleInfo "History: Fixed RemoveGadgetItem combobox,index"
ModuleInfo "History: Fixed ModifyGadgetItem combobox,index,label$,extra:Object"
ModuleInfo "History: 1.08 Release"
ModuleInfo "History: Fixed EventX EventY reporting for canvas and panel events"
ModuleInfo "History: 1.07 Release"
ModuleInfo "History: Fixed ClearListItems"
ModuleInfo "History: Fixed some keyboard focus problems"
ModuleInfo "History: Fixed case sensitive shortcut keys issue with fltk1.1.7"
ModuleInfo "History: Fixed Canvas depthbuffers"
ModuleInfo "History: 1.06 Release"
ModuleInfo "History: Upgraded to fltk-1.1.7"
ModuleInfo "History: Fixed GadgetHidden()"
ModuleInfo "History: Initial support code added for WINDOW_CHILD"
ModuleInfo "History: Fixed implementation of ActiveGadget"
ModuleInfo "History: 1.05 Release"
ModuleInfo "History: Fixed MouseEnter and MouseLeave for Panel / Canvas children"
ModuleInfo "History: Fixed SelectGadgetItem not generating event for ListBoxes"
ModuleInfo "History: Fixed font support for TextField gadgets"
ModuleInfo "History: Fixed EventExtra reporting in ListBox events"
ModuleInfo "History: 1.04 Release"
ModuleInfo "History: Removed RuntimeError from TFLSystem.OpenURL"
ModuleInfo "History: 1.02 Release"
ModuleInfo "History: Fixed up mouse events for active panels and canvas gadgets"
ModuleInfo "History: 1.01 Release"
ModuleInfo "History: Added Query(QUERY_FLWIDGET) and Query(QUERY_FLWIDGET_CLIENT)"

?Linux
ModuleInfo "CC_OPTS: `freetype-config --cflags`"
?

Import "fltkgui.bmx"
