Strict
Import "gadget.bmx"
Import "guifont.bmx"
Import MaxGUI.Localization
Import Brl.Map

'-------------- degac's change -------------------
'set defaults (alignment)
'			this is an array with default value/key
'			key				default parameter
'			0					0 0 0 0
Global MAXGUI_DEFAULT:Int[][]
MAXGUI_DEFAULT=MAXGUI_DEFAULT[..5]	'just one for the moment!


For Local l:Int = 0 Until Len( MAXGUI_DEFAULT )
       MAXGUI_DEFAULT[ l ] = MAXGUI_DEFAULT[ l ][ .. 5 ]
Next

MAXGUI_DEFAULT[0]=[0,0,0,0,0]


'-------------- AutoAlignment

Const MAXGUI_NOALIGNMENT:Int=0
Const MAXGUI_HORIZONTAL:Int=1
Const MAXGUI_VERTICAL:Int=2

Global MAXGUI_ALIGN_LIST:TList
Global MAXGUI_CURRENT_PARENT:tgadget
Global MAXGUI_ORIGINAL_PARENT:tgadget
Global maxgui_align_parent:tgadget
Global MAXGUI_ALIGNMENT:Int=MAXGUI_NOALIGNMENT
Global maxgui_align_size:Int=0
Global maxgui_gadget_w:Int
Global maxgui_gadget_h:Int
Global maxgui_align_last_x:Int
Global maxgui_align_last_y:Int
Global maxgui_Default_h:Int=25

Type MaxGUI_Aligner
	Field parent:MaxGUI_Aligner
	Field items:TList
	Global map_Gadget:Tmap
	Field w:Int,h:Int
	Function Add:maxgui_aligner(g:tgadget)
		Local nn:maxgui_aligner=New maxgui_aligner
		nn.w=g.getwidth()
		nn.h=g.getheight()
		If maxgui_aligner(MapValueForKey(maxgui_aligner.map_gadget,g))<>Null Return Null
		MapInsert maxgui_aligner.map_Gadget,g,nn
		Return nn
	End Function
End Type
'to keep track of gadget's state
'ps: it can be used to keep track of other info...
Type tgadgetstate
	Global gadget_map:Tmap=CreateMap()
	Field gadget:tgadget
	Field parent:tgadget
	Field enable_State:Int
	
	Function Add:tgadgetState(_gad:tgadget=Null,_par:tgadget=Null,_STATE:Int=True)
		If _Gad=Null Or _par=Null Return Null
		Local ts:tgadgetState=New tgadgetState
		ts.gadget=_gad
		ts.parent=_par
		ts.enable_state=_STATE
		MapInsert(gadget_map,_gad,ts)
		'DebugLog "Tgadgetstate:add:"+_gad.class()+" "+_gad.name
		Return ts	
	End Function
	
	Function Restore(_Gad:tgadget=Null)
		If _Gad=Null Return		
		Local ts:tgadgetState=TgadgetState(MapValueForKey(gadget_map,_gad))
		If ts
			If ts.enable_state=False 
				_gad.SetEnabled True
			Else
				_gad.SetEnabled False
			End If
			MapRemove gadget_map,_gad
			'DebugLog "Tgadgetstate:remove:"+_gad.class()

		End If
	End Function
	
	
End Type
'-------------- degac's change -------------------


Type TMaxGUIDriver

	Method UserName$() Abstract	
	Method ComputerName$() Abstract
	
	Method LoadFont:TGuiFont(name$,size,flags) Abstract
	Method CreateGadget:TGadget(GadgetClass,name$,x,y,w,h,group:TGadget,style) Abstract
	Method ActiveGadget:TGadget() Abstract
	Method RequestColor(r,g,b) Abstract
	Method RequestFont:TGuiFont(font:TGuiFont) Abstract	
	Method SetPointer(shape) Abstract
	Method LoadIconStrip:TIconStrip(source:Object) Abstract
	
	Method LookupColor( colorindex:Int, pRed:Byte Var, pGreen:Byte Var, pBlue:Byte Var )
		
		Select colorindex
			Case GUICOLOR_WINDOWBG
				pRed = 240; pGreen = 240; pBlue = 240
			Case GUICOLOR_GADGETBG
				pRed = 255; pGreen = 255; pBlue = 255
			Case GUICOLOR_GADGETFG
				pRed = 0; pGreen = 0; pBlue = 0
			Case GUICOLOR_SELECTIONBG
				pRed = 50; pGreen = 150; pBlue = 255
			Case GUICOLOR_LINKFG
				pRed = 0; pGreen = 0; pBlue = 255
		EndSelect
		
		Return False
		
	EndMethod
	
	Method LibraryFont:TGuiFont( pFontType% = GUIFONT_SYSTEM, pFontSize:Double = 0, pFontStyle% = FONT_NORMAL )
		?Win32
		If pFontSize <= 0 Then
			Select pFontType
				Case GUIFONT_SYSTEM;pFontSize = 8
				Case GUIFONT_SERIF;pFontSize = 11
				Default;pFontSize = 10
			EndSelect
		EndIf
		?Not Win32
		If pFontSize <= 0 Then
			pFontSize = 12
			?MacOs
			If pFontType = GUIFONT_SYSTEM Then pFontSize = 11
		?Not Win32
		EndIf
		?
		Select pFontType
			Case GUIFONT_MONOSPACED
				?Linux
				Return LoadFontWithDouble("Lucida",pFontSize,pFontStyle)
				?MacOS
				Return LoadFontWithDouble("Monaco",pFontSize,pFontStyle)
				?Win32
				'Let's give any Vista users the chance to use the new Consolas font.
				Local tmpFont:TGuiFont = LoadFontWithDouble("Consolas",pFontSize,pFontStyle)
				If tmpFont.name = "Consolas" Then Return tmpFont
				Return LoadFontWithDouble("Courier New",pFontSize,pFontStyle)
				?
			Case GUIFONT_SANSSERIF
				?Linux
				Return LoadFontWithDouble("FreeSans",pFontSize,pFontStyle)
				?MacOS
				Return LoadFontWithDouble("Helvetica",pFontSize,pFontStyle)
				?Win32
				Return LoadFontWithDouble("Arial",pFontSize,pFontStyle)
				?
			Case GUIFONT_SERIF
				?Linux
				Return LoadFontWithDouble("FreeSerif",pFontSize,pFontStyle)
				?MacOS
				Return LoadFontWithDouble("Times New Roman",pFontSize,pFontStyle)
				?Win32
				Return LoadFontWithDouble("Times New Roman",pFontSize,pFontStyle)
				?
			Case GUIFONT_SCRIPT
				?Linux
				Return LoadFontWithDouble("TSCu_Comic",pFontSize,pFontStyle)
				?MacOS
				Return LoadFontWithDouble("Comic Sans MS",pFontSize,pFontStyle)
				?Win32
				Return LoadFontWithDouble("Comic Sans MS",pFontSize,pFontStyle)
				?
			Default	'GUIFONT_SYSTEM
				?Linux
				Return LoadFontWithDouble("FreeSans",pFontSize,pFontStyle)
				?MacOS
				Return LoadFontWithDouble("Lucida Grande",pFontSize,pFontStyle)
				?Win32
				Return LoadFontWithDouble("MS Shell Dlg",pFontSize,pFontStyle)
				?
		EndSelect
	EndMethod
	
	Method LoadFontWithDouble:TGuiFont(name$,size:Double,flags)
		Return LoadFont(name,Int(size+0.5),flags)
	EndMethod
	
	' Localization Code
	
	Field _mapLocalized:TMap = CreateMap()
	
	Method SetLocalizationMode( Mode:Int )
		Local tmpApply:Int = False
		If (LocalizationMode() ~ Mode) & LOCALIZATION_ON Then tmpApply = True
		engine_SetLocalizationMode(Mode)
		If tmpApply Then ApplyLanguage()
	EndMethod
	
	Method SetLanguage( language:TMaxGUILanguage )
		engine_SetLocalizationLanguage(language)
		ApplyLanguage()
	EndMethod
	
	Method ApplyLanguage()
		For Local tmpGadget:TGadget = EachIn MapKeys(_mapLocalized)
			ApplyLocalization( tmpGadget )
		Next
	EndMethod
	
	Method SetGadgetLocalization( gadget:TGadget, Text$, tooltip$ )
		If gadget Then
			MapInsert _mapLocalized, gadget, [Text,tooltip]
			ApplyLocalization( gadget )
		EndIf
	EndMethod
	
	Method ApplyLocalization( gadget:TGadget )
		If gadget.Class() <> GADGET_CANVAS Then
			Local tmpString$[] = String[](MapValueForKey( _mapLocalized, gadget ))
			gadget.SetText(LocalizeString(tmpString[0]))
			gadget.SetTooltip(LocalizeString(tmpString[1]))
			For Local i:Int = 0 Until gadget.items.length
				If Max(gadget.ItemFlags(i),0)&GADGETITEM_LOCALIZED Then
					LocalizeGadgetItem( gadget, i )
				EndIf
			Next
		EndIf
	EndMethod
	
	Method LocalizeGadgetItem( gadget:TGadget, index:Int )
		gadget.SetListItem(index,LocalizeString(gadget.ItemText(index)),LocalizeString(gadget.ItemTip(index)),gadget.ItemIcon(index),gadget.ItemExtra(index))
	EndMethod
	
	Method GadgetLocalized:Int( gadget:TGadget )
		Return MapContains( _mapLocalized, gadget )
	EndMethod
	
	Method DelocalizeGadget( gadget:TGadget )
		MapRemove _mapLocalized, gadget
	EndMethod
	
End Type

Global maxgui_driver:TMaxGUIDriver

' Localization Handling

Const LOCALIZATION_OVERRIDE:Int = 2

Private

Function DelocalizeGadget(gadget:TGadget)
	maxgui_driver.DelocalizeGadget(gadget)
EndFunction

Function driver_SetLocalizationMode(Mode:Int)
	maxgui_driver.SetLocalizationMode(Mode)
EndFunction

Function driver_SetLocalizationLanguage(language:TMaxGUILanguage)
	maxgui_driver.SetLanguage(language)
EndFunction

Global engine_SetLocalizationMode( Mode:Int ) = _SetLocalizationMode
Global engine_SetLocalizationLanguage( language:TMaxGUILanguage ) = _SetLocalizationLanguage

_SetLocalizationMode = driver_SetLocalizationMode
_SetLocalizationLanguage = driver_SetLocalizationLanguage

TGadget.LocalizeString = LocalizeString
TGadget.DelocalizeGadget = DelocalizeGadget
Public


Rem
bbdoc: Set the alignment of the next gadgets.
about: You can specify the alignment as
[ @Constant | @{Alignment
* MAXGUI_NOALIGNMENT | No alignment
* MAXGUI_HORIZONTAL | Horizontal alignment
* MAXGUI_VERTICAL | Vertical alignment
]

@size parameter specifies the distance from the borders.
see #DoAlignment
EndRem
Function SetGadgetAlignment:Int(parent:tgadget=Null,al:Int=MAXGUI_NOALIGNMENT,size:Int=0)
	MAXGUI_ALIGNMENT=al
	maxgui_align_parent=parent
	maxgui_align_size=size
	maxgui_current_parent=parent
	If parent=Null DebugLog "Warning: SetGadgetAlignment:Parent=NULL!!!"

End Function
Rem
bbdoc: apply the alignment rules
about: see #SetGadgetAlignment
End Rem
Function DoAlignment:Int()
	If maxgui_align_list=Null DebugLog "DoAlignment: no list of gadgets";Return
	If maxgui_align_parent=Null DebugLog "DoAlignment: no parent";Return
	
	
		
	Local w1:Int=maxgui_align_parent.getwidth()-maxgui_align_size*2
	Local h1:Int=maxgui_align_parent.getHEIGHT()-maxgui_align_size*2
	Local xx:Int,yy:Int,gw:Int,gh:Int,counter:Int=1
	Local items:Int=maxgui_align_list.count()
	Local stepx:Int,stepy:Int,TEMP:maxgui_aligner
	
	
	If items=0 items=1;DebugLog "WARNING: you missed SetGadgetAlignment() - please check your code!"
	stepx=w1/items
	stepy=h1/items
	
	If maxgui_align_parent.class()=GADGET_SCROLLPANEL
		DebugLog "DoAlignment: gadgets are in a scroll panel"
		DebugLog "Size of panel : "+maxgui_align_parent.getwidth()+" x "+maxgui_align_parent.getHEIGHT()
		stepX=64
		stepy=32
		
	End If

	
	xx:+maxgui_align_size
	yy:+maxgui_align_size

	gw=stepx
	gh=stepy
	
	For Local g:tgadget=EachIn maxgui_align_list
		
		
		If maxgui_alignment=MAXGUI_VERTICAL
			gh=stepy
			temp=maxgui_aligner(MapValueForKey(maxgui_aligner.map_Gadget,g))
			If temp
				gh=temp.h
				If (gh=-1 Or gh=0)	
					gh=stepy
				Else
					If (items-counter)=1 Exit
					If (items-counter)>0 stepy=(h1-yy-gh+maxgui_align_size)/(items-counter)
				End If
			End If
			g.SetShape maxgui_align_size,yy,w1,gh
			yy:+gh
			maxgui_align_last_y=yy
		End If
		
		If maxgui_alignment=MAXGUI_HORIZONTAL
			gw=stepx
			temp=maxgui_aligner(MapValueForKey(maxgui_aligner.map_Gadget,g))
			If temp
				gw=temp.w
					If (gw=-1 Or gw=0)	
					gw=stepx
				Else
					If (items-counter)=0 Exit

					If (items-counter)>0 stepx=(w1-xx-gw+maxgui_align_size)/(items-counter)
				End If
			End If
			g.SetShape xx,maxgui_align_size,gw,h1
			xx:+gw
			maxgui_align_last_x=xx
		End If
		
		
		counter:+1
	Next
	maxgui_align_list.clear()
	maxgui_alignment=MAXGUI_NOALIGNMENT
	maxgui_align_parent=MAXGUI_ORIGINAL_PARENT
	maxgui_align_last_y=maxgui_align_parent.GetHeight()+maxgui_align_parent.ypos
	ClearMap maxgui_aligner.map_gadget
End Function


Function AddAlignGadget:tgadget(gg:tgadget,x:Int=-1,y:Int=-1,w:Int=-1,h:Int=-1,par:tgadget=Null,sty:Int=0)
	If par=Null par=maxgui_align_parent;DebugLog "Parent: MaxGUI_align_parent"
	If MAXGUI_ALIGN_LIST=Null MAXGUI_ALIGN_LIST=New TList
	
	If maxgui_aligner.map_gadget=Null
		maxgui_aligner.map_gadget=CreateMap()
	End If
	
	
	If h=-1 And MAXGUI_ALIGN_LIST.count()=0 h=MAXGUI_DEFAULT_H
	
	If x=-1 x=0
	If y=-1 y=maxgui_align_last_y
	
	maxgui_aligner.add(gg)

	If maxgui_alignment=MAXGUI_VERTICAL
		gg.SetLayout EDGE_ALIGNED,EDGE_ALIGNED,EDGE_RELATIVE,EDGE_RELATIVE
	ElseIf maxgui_alignment=MAXGUI_HORIZONTAL
		gg.SetLayout EDGE_RELATIVE,EDGE_RELATIVE,EDGE_ALIGNED,EDGE_ALIGNED
	End If
	If maxgui_alignment<>MAXGUI_NOALIGNMENT MAXGUI_ALIGN_LIST.addlast gg
	
	If w>-1 maxgui_gadget_w=w
	If h>-1 maxgui_gadget_h=h

	maxgui_align_last_y=y+gg.getheight()
	
	Return gg

End Function

Rem
bbdoc: Add in one batch, many items to a gadget
about: with this command you can add many items to a gadget (like listbox or combobox) passing them in an array, a list or a map (key values are considered)
@sel parameter indicates what item is 'selected'
End Rem
Function AddGadgetItems:Int(gadget:tgadget,obj:Object=Null,sel:Int=-1)
	If gadget=Null Return -1
	If obj=Null Return -1
	
	Local tmp:Object
	
	If obj=String[](obj)
		For Local s:String=EachIn String[](obj)
		'gadget.ItemCount(),Text,tip,icon,extra,flags)
			gadget.InsertItem(gadget.ItemCount(),s,s,-1,Null,0)
		Next
	End If
	
	If obj=TList(obj)
		For Local s:String=EachIn TList(obj)
		gadget.InsertItem(gadget.ItemCount(),s,s,-1,Null,0)		
		Next
	End If
	
	If obj=tmap(obj)
			For Local s:String=EachIn MapKeys(tmap(obj))
			tmp=MapValueForKey(tmap(obj),s)
			gadget.InsertItem(gadget.ItemCount(),s,s,-1,tmp,0)
			Next
	End If
	If sel<>-1
		gadget.SelectItem(sel,1)

	End If
End Function

Rem
bbdoc: Set Label Style of the text
about: This is a @work in progress@. Just works only with LABEL (Win32/FLTK)
End Rem
Function SetTextAlignment(gadget:tgadget,alignment:Int)
	gadget.SetTextAlign(alignment)
End Function

Rem
bbdoc: Change a gadget style 
about: This is a @work in progress@. Just works only with LABEL under FLTK driver
End Rem
Function SetGadgetStyle(gadget:Tgadget,style:Int)
	gadget.ChangeStyle(style)
End Function

Rem
bbdoc: Turn on or off a specifict default behaviour
about: @key is one supported by #SetGadgetDefault()<br>
@state could be 1 (on) or 0 (off)
EndRem
Function GadgetDefault:Int(key$,state:Int=0)
		Select key.toupper()
			Case "LAYOUT"	MAXGUI_DEFAULT[0][0]=state
			Case "FGCOLOR"	MAXGUI_DEFAULT[1][0]=state
			Case "BGCOLOR"	MAXGUI_DEFAULT[2][0]=state
			Case "ENABLED" MAXGUI_DEFAULT[3][0]=state
			Case "HIDDED" 	MAXGUI_DEFAULT[4][0]=state
		End Select
Return 0

End Function

Rem
bbdoc: Set default behaviour for gadget
about: You can specify some of 'default' behaviour gadgets will have.<br>
@Key is a string (case insensitive) that defines one of the 'behaviour'.<br>
@parameters is an INT ARRAY: so you need to pass values as [255,200,200].<br>
<br>
[
* @Key | @parameters
* layout | 4: a,b,c,d - like in #SetGadgetLayout()
* fgcolor | 3: a,b,c - like in #SetTextColor()
* bgcolor | 3: a,b,c - like in #SetGadgetColor()
* enabled | 1:       - 1,0 #EnableGadget() / #DisableGadget()
* hidden  | 1:       - 1,0 #HideGadget()/ #ShowGadget()
]
EndRem
Function SetGadgetDefault:Int(key$,value:Int[])
		'key: LAYOUT		 [A,B,C,D]
		Select KEY.toupper()
			Case "LAYOUT"
					value=value[..4]
					MAXGUI_DEFAULT[0][1]=value[0]
					MAXGUI_DEFAULT[0][2]=value[1]
					MAXGUI_DEFAULT[0][3]=value[2]
					MAXGUI_DEFAULT[0][4]=value[3]
					MAXGUI_DEFAULT[0][0]=1

			Case "HIDDEN"
					value=value[..1]
					MAXGUI_DEFAULT[4][1]=value[0]
					MAXGUI_DEFAULT[4][0]=1

			Case "ENABLED"
					value=value[..1]
					MAXGUI_DEFAULT[3][1]=value[0]
					MAXGUI_DEFAULT[3][0]=1


			Case "FGCOLOR"
					value=value[..3]
					MAXGUI_DEFAULT[1][1]=value[0]
					MAXGUI_DEFAULT[1][2]=value[1]
					MAXGUI_DEFAULT[1][3]=value[2]
					MAXGUI_DEFAULT[1][0]=1

			Case "BGCOLOR"
					value=value[..3]
					MAXGUI_DEFAULT[2][1]=value[0]
					MAXGUI_DEFAULT[2][2]=value[1]
					MAXGUI_DEFAULT[2][3]=value[2]
					MAXGUI_DEFAULT[2][0]=1

	
		End Select
		
Return 0
End Function

Function ApplyDefault:Int(gadget:Tgadget)
	If gadget=Null Return 0

	'apply defaults
		
		If MAXGUI_DEFAULT[0][0]=1	'layout
			gadget.setLayout MAXGUI_DEFAULT[0][1],MAXGUI_DEFAULT[0][2],MAXGUI_DEFAULT[0][3],MAXGUI_DEFAULT[0][4]
		End If
		
		If MAXGUI_DEFAULT[1][0]=1	'fgcolor
			gadget.SettextColor MAXGUI_DEFAULT[1][1],MAXGUI_DEFAULT[1][2],MAXGUI_DEFAULT[1][3]
		End If
		
		If MAXGUI_DEFAULT[2][0]=1	'bgcolor
			gadget.SetColor MAXGUI_DEFAULT[2][1],MAXGUI_DEFAULT[2][2],MAXGUI_DEFAULT[2][3]
		End If

		If MAXGUI_DEFAULT[3][0]=1	'disabled
			gadget.SetShow MAXGUI_DEFAULT[3][1]

		End If


End Function
