SuperStrict

Import MaxGUI.MaxGUI
Import brl.max2d
Import "common.bmx"
Rem
bbdoc: This creates a Tabber gadget automatically managed.
about:This means you have already all the code to swap tabs

You can use the standard MaxGUI commands, like #AddGadgetItem, #ModifyGadgetItem, #RemoveGadgetItem, #ClearGadgetItems, #DisableGadgetItem, #EnableGadgetItem or #SetGadgetIconStrip

@GadgetExtra contains an array of gadgets refering to every single tabs

End Rem
Function CreateTabberManager:tTabberManager(x:Int,y:Int,w:Int,h:Int,g:Tgadget,s:Int=0)
	Return TtabberManager.Create(x,y,w,h,g,s)
End Function


Type TtabberManager Extends Tproxygadget
	Field tabber:Tgadget
	Field documents:tgadget[],state:Int[]
	Field current_tab:tgadget
	Field current_tab_id:Int
	Field doc_count:Int
	Field icons:Ticonstrip,grey_icons:Ticonstrip

	Method ItemCount:Int()
		Return documents.length
	End Method
	
		Method class:Int()
		Return GADGET_TABBERMANAGER
	End Method
	
	Method ItemState:Int(index:Int)
		?debug
		If index<0 Or index>documents.length-1 Throw "Index out of range"
		?
			If documents[index]	Return state[index]
	End Method
	
	Method SetItemState:Int(index:Int,ste:Int)
	?debug
	If index<0 Or index>documents.length Throw "Index out of range"
	?

		If ste=STATE_ACTIVE
			If documents[index]
			EnableGadget documents[index]
			state[index]=STATE_DISABLED
			End If
		Else
			If documents[index]
			DisableGadget documents[index]
			state[index]=STATE_ACTIVE
			End If
		End If
	End Method

	
	Method SetEnabled:Int(status:Int=True)
		If status=True
			EnableGadget tabber
			SetGadgetIconStrip tabber,icons
		Else
			SetGadgetIconStrip tabber,grey_icons
			DisableGadget tabber
		End If

	End Method
	
	
	Method CleanUp:Int()
		RemoveHook EmitEventHook,EventHandler,Self
		Clear
		icons=Null
		grey_icons=Null
		Super.CleanUp()
	End Method
	
	Method RemoveItem:Int(index:Int)
		?debug
		If index<0 Or index>documents.length-1 Throw "Index out of range"
		?	
		If documents[index].kids FreeGadget documents[index]';DebugLog "Kids removed..."
		documents[index]=Null
		state[index]=-1
		For Local t:Int=index+1 Until documents.length
			documents[t-1]=documents[t]
			state[t-1]=state[t]
		Next
		documents=documents[..documents.length-1]
		state=state[..state.length-1]
		RemoveGadgetItem tabber,index
		GCCollect()
		If index>=Len(documents) index=Len(documents)-1		
		ShowPage(index)
		current_tab_ID=index
		tgadget(Super).extra=documents
		
	End Method

	
Method ShowPage:Int(id:Int=0)
		?debug
		If id<0 Or id>documents.length-1 Throw "Index out of range"
		?
		For Local p:Int=0 Until documents.length
			If documents[p] HideGadget documents[p]
		Next
		If documents[id] 
			current_tab=documents[id]
			SelectGadgetItem tabber,ID
			ShowGadget documents[id]
			current_tab_id=ID
		End If
End Method

	Method Clear:Int()
		For Local p:Int=0 Until documents.length
			If documents[p] FreeGadget documents[p];documents[p]=Null
		Next
		documents=Null
		icons=Null
		grey_icons=Null
		tgadget(Super).extra=documents
		ClearGadgetItems tabber
	End Method


Method SelectItem:Int(index:Int,opt:Int=0)
	?debug
	If index<0 Or index>documents.length-1 Throw "Index out of range"
	?
	ShowPage(index)	
End Method

Method SetIconStrip:Int(ics:Ticonstrip)
	icons=ics
	SetGadgetIconStrip tabber,ics
	grey_icons=ticonstrip(Makegrey(ics))
End Method

Method SetItem:Int(index:Int,Text:String,tip:String,icon:Int,extra:Object,flags:Int)
		?debug
		If index<0 Or index>documents.length Throw "Index out of range"
		?	
		If documents[index]
			extra=Null
			ModifyGadgetItem tabber,index,text,flags,icon,tip,extra
		End If

End Method

Method InsertItem:Int(index:Int,text:String,tip:String,icon:Int,extra:Object,flags:Int)
		?debug
		If index<0 Or index>documents.length Throw "Index out of range"
		?	
		documents=documents[..documents.length+1]
		state=state[..state.length+1]
		state[index]=STATE_ACTIVE
		InsertGadgetItem tabber,index,text,flags,icon,tip,extra
		documents[index]=_CreateDocument(tabber)
		ShowGadget documents[index]
		tgadget(Super).extra=documents
		Rem
		If index<documents.length
			
			documents=documents[..documents.length+1]
			For Local i:Int=documents.length-2 To index Step -1
				documents[i+1]=documents[i]
			Next
			
			InsertGadgetItem tabber,index,text,flags,icon,tip,extra
			documents[index]=_CreateDocument(tabber)
		Else
			documents=documents[..doc_count+1]
			documents[doc_count]=_CreateDocument(tabber)
			extra=documents[doc_count]
			doc_count:+1
			AddGadgetItem tabber,text,flags,icon,tip,extra

		End If
		End Rem
		
	End Method

Function _CreateDocument:TGadget(tabber:TGadget)
		Local	panel1:TGadget
		panel1=CreatePanel(0,0,ClientWidth(tabber),ClientHeight(tabber),tabber)
		SetGadgetLayout panel1,1,1,1,1
		HideGadget panel1
		Return panel1
End Function

Function Create:TtabberManager (x:Int,y:Int,w:Int=-1,h:Int=-1,group:tgadget,style:Int=0)
		
		Local sp:TtabberManager =New TtabberManager 	
		sp.tabber=CreateTabber(x,y,w,h,group,style)
		SetGadgetLayout sp.tabber,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		AddHook EmitEventHook,EventHandler,sp
		sp.setproxy(sp)
		Return sp
	End Function

	Function eventHandler:Object( pID%, pData:Object, pContext:Object )
		Local pEvent:TEvent =  TEvent(pData)
		Local obj:TtabberManager = TtabberManager (pContext)
		Local source_tab:String
		
		If pEvent
			Select pevent.ID
			Case EVENT_GADGETACTION
				If pevent.source=obj.tabber
					obj.ShowPage(pevent.data)
					Return pData
				EndIf
		End Select
			
		End If
		Return pData
		
	EndFunction

End Type
