Strict

Import MaxGUI.MaxGUI
Import brl.timer
Rem
	Notify Gadget
	 2010 - degac - www.graphio.net

	1.0 - Initial release
	1.1 - Supports for animated images
	1.2 - Button is now an 'OK button', just press RETURN to close the window

End Rem

Rem
bbdoc: a notify gadget with personalized image/animation
about: @msg is the message you want to display<br>@group is the parent window<br>@pix is an object (a pixmap or an IconStrip object)<br>See #LoadPixmap and #LoadIconStrip for more informations.
<br>Images should be 128x128 pixel in size.
End Rem
Function CreateNotify:Int (msg:String="",group:tgadget,pix:Object=Null)
	Return Tnotifygadget.Create(msg$,0,group:tgadget,pix)
End Function

Type Tnotifygadget Extends Tproxygadget

	Field text:tgadget		'the text/message
	Field BUTTON_OK:tgadget		'the OK button
	Field BUTTON_CANCEL:tgadget
	Field button_abort:tgadget
	Field panel:tgadget		'the (optional) image
	Field pixmap:Object		'the (optional) pixmap
	Field window:tgadget		'the window
	Field old_window:tgadget	'the parent window
	Field LINE:TGADGET,style:Int
	Field TIMER:TTIMER,frame:Int,maxframe:Int
	Field _destroy:Int

	Method CleanUp()

		If pixmap pixmap=Null
		If TIMER StopTimer timer;timer=Null
		If panel FreeGadget panel;panel=Null
		If BUTTON_OK FreeGadget BUTTON_OK;BUTTON_OK=Null
		If BUTTON_CANCEL FreeGadget BUTTON_CANCEL;BUTTON_CANCEL=Null
		If button_abort FreeGadget button_abort;button_abort=Null
		RemoveHook EmitEventHook,EventHandler,Self
		If text FreeGadget text;text=Null
		If window FreeGadget window;window=Null
	
		Super.CleanUp()
		
	End Method
	
	Function Create:Int (msg$,style:Int=0,group:tgadget=Null,img:Object=Null)
		Local sp:Tnotifygadget =New Tnotifygadget 		
		Local size:Int=200,xtext:Int=10
		
		Local iconstrip:ticonstrip=ticonstrip(img)
		Local pixmap:TPixmap=TPixmap(img)
		
		sp.style=style
		
		If pixmap
			size=400
			xtext=180
		End If
		If iconstrip
			sp.timer=CreateTimer(5)
			size=400
			xtext=180
			sp.maxframe=iconstrip.count
		End If
		
		sp.pixmap=img
		
		Local cx:Int,cy:Int
		cx=group.xpos
		cy=group.ypos+20
		
		sp.window=CreateWindow(AppTitle,cx,cy,size,200,,WINDOW_TITLEBAR)
		sp.old_window=group
	
		sp.text=CreateLabel(msg,xtext,10,ClientWidth(sp.window)-xtext-10,ClientHeight(sp.window)-40,sp.window)',LABEL_FRAME)
		
		sp.line=CreateLabel("",0,ClientHeight(sp.window)-30,ClientWidth(sp.window),30,sp.window,LABEL_SEPARATOR)
		
		sp.panel=CreatePanel(10,10,128,128,sp.window)
		If pixmap SetGadgetPixmap sp.panel,pixmap,PANELPIXMAP_FIT2
		
		If iconstrip
			pixmap=PixmapFromIconStrip(iconstrip,sp.frame)
			SetGadgetPixmap sp.panel,pixmap,PANELPIXMAP_FIT2
		End If
		
		Local x:Int=ClientWidth(sp.window)/2-40	
		SP.BUTTON_OK=CreateButton("Ok",x,ClientHeight(sp.window)-25,80,24,sp.window,BUTTON_OK)
						
		DisableGadget group
		ActivateWindow sp.window
		sp.SetProxy sp.window
		AddHook EmitEventHook,EventHandler,sp
	End Function
	
	Function eventHandler:Object( pID%, pData:Object, pContext:Object )
		Local pEvent:TEvent =  TEvent(pData)
		Local obj:Tnotifygadget = Tnotifygadget (pContext)
		
		If pEvent
		
			Select pevent.ID
				Case EVENT_TIMERTICK
					If pevent.source=obj.timer
						obj.frame=(obj.frame+1) Mod obj.maxframe
						Local pixmap:TPixmap
						pixmap=PixmapFromIconStrip(ticonstrip(obj.pixmap),obj.frame)
						SetGadgetPixmap obj.panel,pixmap,PANELPIXMAP_FIT2
					End If
					
				Case EVENT_GADGETACTION
					If obj.style=0
						If pevent.source=obj.BUTTON_OK
							ActivateWindow obj.old_window
							EnableGadget obj.old_window
							ActivateGadget obj.old_window
							FreeGadget obj
							'Return Null
						End If
					End If
			
				Case EVENT_WINDOWCLOSE

					If pevent.source=obj
						ActivateWindow obj.old_window
						FreeGadget obj
						EnableGadget obj.old_window
						ActivateGadget obj.old_window
						'Return Null
					End If
			
			End Select

			
		End If
		
	
	'	Return Null	'in this way NO events are passed to the MAIN program
	EndFunction


End Type

